# Shoelace::Rails::Ui
Get started with [Shoelace](https://shoelace.style/) today, the Rails way!

## What this gem gives you

* Out-of-the-box shoelace
* `sl_my_component(my_attribute:"")`-style ERB syntax for composing HTML with these components
* `sl_form` helpers to write forms the Rails way, supercharged with Shoelace      
  * authored originally by @yuki24 in [shoelace-rails](https://github.com/yuki24/shoelace-rails)

## Usage

1. Add to gemfile and `bundle install`
1. `rails g shoelace:install`
1. presto!

## Requirements
* Rails 7.0 or greater with defaults (hotwire, importmaps, etc.)

## Not required

* custom javascript
* custom css
* yarn
* webpack
* node

## Docs

[All components](#)
[Example rails application](https://github.com/Schwad/shoelace_rails_ui_test_application)

UPNEXT: gem load right in ci; get push; test against another rails app from gem push;
practice demo; tidy up the readme

## Workload for MVP _(contribute today!)_

| Todo  | Status |
| ------------- | ------------- |
| `rails generate shoelace:install` one-step to shoelace | ✅ |
| Render nested shoelace components  | ✅ |
| Include assets | ✅ |
| V1 codegen | ✅ |
| V2 codegen (with @kddnewton's guidance implemented) | 🔲 |
| Basic gen test coverage | 🔲 |
| All components test covered | 🔲 |
| Github Action CI | ✅ |
| Render icons  | 🔲  |
| Autogen docs site  | 🔲  |
| Version parity with shoelace  | 🔲  |
| *BUG* - double text render | ✅ |

## Notes

Codegen could be generated by a [scrape online](https://cdn.jsdelivr.net/npm/@shoelace-style/shoelace@2.0.0-beta.64/dist/components/alert/alert.d.ts) instead of a full pull. ( [Alernatively, unpkg](https://unpkg.com/) )

## License
The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).
